#################################################################################
#   WalkFX Module                                                               #
#   Lets captin walk round the bridge                                           #
#                                                                               #
#   Created by BCS:TNG for a HUGE secret upcomming mod                          #
#       v0.0.1 -- Lost_Jedi aka John Hardy 09/10/2005                           #
#           ~Works fine for me.                                                 #
#       v0.0.2 -- Lost_Jedi aka John Hardy 15/10/2005                           #
#           ~Added:                                                             #
#                   - Easier to access key events                               #
#                   - SeatBelt Button                                           #
#                       - Free Float Mode                                       #
#                       - Walking Mode                                          #
#                   - Sinusoidal Walking Movment                                #
#                   - Run Factor for easy access to speeds                      #
#                   - Sounds as the player walks                                #
#                   - Spelling of Handlers corrected ;)                         #
#                                                                               #
#################################################################################
# Imports
import App
import Foundation
from math import sin
# Constants
FALSE = 0
TRUE = 1
ET_WALKFX = App.UtopiaModule_GetNextEventType()
mode = Foundation.MutatorDef("WalkFX")
global FreeFloat
global WalkSpeed, RunFactor

#################################################################################
# STUFF THE GAMER MAY WANT TO PLAY WITH                                         #
                                                                                
WalkSpeed = 1.5                 # The smaller, the slower, the smoother         
RunFactor = 2.00                # The factor that running is faster than walking

RunForwardKey = App.WC_CAPS_N   # Which Key Is pressed to run forwards
ForwardKey = App.WC_N           # Which Key Is pressed to walk forwards
BackwardKey = App.WC_B          # Which Key Is pressed to walk backwards
                                                                                #
#################################################################################

global StepsTaken       # Holds the sinusoidal number that gives the effect of walking
StepsTaken = 0          # It starts off at 0

# Setup Walking Sounds
global pSoundStep1, pSoundStep2, pSoundStep3, pSoundStep4, PlayedStepSoundCount, ToPlayStepSoundCount
PlayedStepSoundCount = 0
ToPlayStepSoundCount = 0
pSoundStep1 = App.TGSound_Create("sfx/Custom/WalkFX/steps/step1.wav", "Step1", 0)
pSoundStep2 = App.TGSound_Create("sfx/Custom/WalkFX/steps/step1.wav", "Step2", 0)
pSoundStep3 = App.TGSound_Create("sfx/Custom/WalkFX/steps/step1.wav", "Step3", 0)
pSoundStep4 = App.TGSound_Create("sfx/Custom/WalkFX/steps/step1.wav", "Step4", 0)

pSoundStep1.SetSFX(0)
pSoundStep1.SetInterface(1)
pSoundStep2.SetSFX(0)
pSoundStep2.SetInterface(1)
pSoundStep3.SetSFX(0)
pSoundStep3.SetInterface(1)
pSoundStep4.SetSFX(0)
pSoundStep4.SetInterface(1)
 
def GetSinusoidalHeightFromStepNumber():
    global StepsTaken 
    StepsTaken = StepsTaken + 0.5
                               
    if (StepsTaken == 99999):   # <--- So I 'worked round'/bodged it with this
        StepsTaken = 0          #       to prevent step overflow
        
    sHeight = 0.0000
    sHeight = sin(StepsTaken)
    return sHeight
   
def PlayStepSound(isRunning = FALSE):
    # Plays a walking sound
    global PlayedStepSoundCount, ToPlayStepSoundCount, RunFactor
    if(isRunning == TRUE):
        PlayedStepSoundCount = PlayedStepSoundCount + (RunFactor / 10)
    else:
        PlayedStepSoundCount = PlayedStepSoundCount + 0.1

    if(PlayedStepSoundCount >= 2):
        if(ToPlayStepSoundCount == 0):
            # Play Sound 1
            App.g_kSoundManager.PlaySound("Step1")
        elif(ToPlayStepSoundCount == 1):
            # Play Sound 2
            App.g_kSoundManager.PlaySound("Step2")
        elif(ToPlayStepSoundCount == 2):
            # Play Sound 3
            App.g_kSoundManager.PlaySound("Step3")
        elif(ToPlayStepSoundCount == 3):
            # Play Sound 4
            App.g_kSoundManager.PlaySound("Step4")

        # Increment Sound Counter        
        ToPlayStepSoundCount = ToPlayStepSoundCount + 1
        if(ToPlayStepSoundCount == 4):
            ToPlayStepSoundCount = 0
        
        PlayedStepSoundCount = 0
        
    return TRUE

    
def GetBridgeCamera():
    pSet = App.g_kSetManager.GetSet ("bridge")
    if not pSet:
        # If we are not in the bridge then return false
        return FALSE
    
    pCamera = App.CameraObjectClass_GetObject(pSet, "maincamera")
    if (pCamera == None):
            return FALSE

    return pCamera
    
def MoveForward(mUnits, isRunning = FALSE):
    global FreeFloat
    # Move the Camera Forward in the direction its facing
    pCamera = GetBridgeCamera()
    if(pCamera == FALSE):
        return FALSE

    cForward = pCamera.GetWorldForwardTG()
    cPos = pCamera.GetWorldLocation()
    
    x = (cPos.GetX() + (cForward.GetX() * mUnits))
    y = (cPos.GetY() + (cForward.GetY() * mUnits))
    
    if(FreeFloat == TRUE):
        # Free Floating Camera is on
        z = (cPos.GetZ() + (cForward.GetZ() * mUnits))
    else:
        # Free Floating Camera is off
        if(isRunning == TRUE):
            z = (cPos.GetZ() + GetSinusoidalHeightFromStepNumber())
        else:
            global RunFactor
            z = (cPos.GetZ() + GetSinusoidalHeightFromStepNumber() / RunFactor)
        PlayStepSound(isRunning)
    
    pCamera.SetTranslateXYZ(x,y,z)
    
    return TRUE  

class WalkFX(Foundation.TriggerDef):
	def __init__(self, dict = {}):
		Foundation.TriggerDef.__init__(self, "WalkFX", ET_WALKFX, dict = {})
		
	def __call__(self, pObject, pEvent):
                global WalkSpeed, RunFactor

		dir = pEvent.GetInt()
		if (dir == 101):
                    # Move Camera Forward
			cSpeed = WalkSpeed
			MoveForward(cSpeed)
                        
		elif (dir == 102):
                    # Move Camera Backward
			cSpeed = -WalkSpeed
			MoveForward(cSpeed)
                        
		elif (dir == 103):
                    # Run Camera Forwards
			cSpeed = WalkSpeed * RunFactor
			MoveForward(cSpeed,TRUE)

		return 0
                   
WalkFX(dict = {"modes": [mode]})

# Setup Key Event Handlers
# Forward
App.g_kKeyboardBinding.BindKey(ForwardKey, App.TGKeyboardEvent.KS_NORMAL, ET_WALKFX, App.KeyboardBinding.GET_INT_EVENT, 101)
# Backward
App.g_kKeyboardBinding.BindKey(BackwardKey, App.TGKeyboardEvent.KS_NORMAL, ET_WALKFX, App.KeyboardBinding.GET_INT_EVENT, 102)
# Run Forward
App.g_kKeyboardBinding.BindKey(RunForwardKey, App.TGKeyboardEvent.KS_NORMAL, ET_WALKFX, App.KeyboardBinding.GET_INT_EVENT, 103)

#################################################################################
# GUI STUFF BELOW THIS POINT                                                    #
#

global bWalkMode, bFreeFloat    # Buttons

class WALKFXGUI(Foundation.TriggerDef):
        def __init__(self, name, eventKey, dict = {}):
                Foundation.TriggerDef.__init__(self, name, eventKey, dict)

        def __call__(self, pObject, pEvent, dict = {}):
		BuildWalkFXMenu()
# I needed an event which says when the mission starts, build the menu's.
#    this will do for now i think.  Please say if there is a better way!
WALKFXGUI('WALKFXGUI', App.ET_MISSION_START, dict = { 'modes': [ mode ] } )

def BuildWalkFXMenu():
    global FreeFloat
    global bWalkMode, bFreeFloat    # Buttons

    # Builds the menu for WalkFX
    pTacticalControlWindow = App.TacticalControlWindow_GetTacticalControlWindow()
    # <TGL Database Stuff>
    pDatabase = App.g_kLocalizationManager.Load("data/TGL/Bridge Menus.tgl")
    pXOMenu = pTacticalControlWindow.FindMenu(pDatabase.GetString("XO"))
    
    pWalkMenuName = pDatabase.GetString("Objectives")
    pWalkMenuName.SetString("SeatBelt")
    App.g_kLocalizationManager.Unload(pDatabase)
    # </TGL Database Stuff>
    
    pWalkMenu = App.STCharacterMenu_CreateW(pWalkMenuName)
    pXOMenu.AddChild(pWalkMenu)    

    # Events
    WFX_FREEFLOAT = App.Game_GetNextEventType()
    WFX_WALKMODE = App.Game_GetNextEventType()

    # Create Free Float Button
    bFreeFloat = CreateButton("Free Float", WFX_FREEFLOAT, pWalkMenu)
    pWalkMenu.AddChild(bFreeFloat)
    # Create Walk Mode Button
    bWalkMode = CreateButton("Walk Mode", WFX_WALKMODE, pWalkMenu)
    pWalkMenu.AddChild(bWalkMode)

    # Add what happens when you press the buttons
    pWalkMenu.AddPythonFuncHandlerForInstance(WFX_FREEFLOAT, __name__ + ".StartFREEFLOAT")
    pWalkMenu.AddPythonFuncHandlerForInstance(WFX_WALKMODE, __name__ + ".StartWALKMODE")

    # Start with Free Float OFF
    StartWALKMODE()

    # Insert Fix for Galaxy Bridge here
    #   - I had a go at changing the scripts\Bridge\defiantbridge.py file
    #       and I got it to load, but the charecters were all in the wrong places
    #       so If anyone knows the correct init sub for each charecter could they
    #       have a go. Thanks, LJ

    return TRUE
  
def StartFREEFLOAT(pObject = None, pEvent = None):
    # Turn Free Float Mode on 
    global FreeFloat
    global bWalkMode, bFreeFloat    # Buttons
    
    bWalkMode.SetEnabled()
    bFreeFloat.SetDisabled()
    
    FreeFloat = TRUE

    return TRUE

def StartWALKMODE(pObject = None, pEvent = None):
    # Turn WalkMode On
    global FreeFloat
    global bWalkMode, bFreeFloat    # Buttons

    bWalkMode.SetDisabled()
    bFreeFloat.SetEnabled()    
    
    FreeFloat = FALSE
    
    return TRUE

def CreateButton(name, eventNumber, eventMenu):
    # Creates a button
    myButton = None
    event = App.TGIntEvent_Create()
    event.SetEventType(eventNumber)
    event.SetDestination(eventMenu)
    
    myButton = App.STButton_Create(name, event)
   
    return myButton
